use crate::scene::*;
use crate::offaxis::*;
use crate::screeninfo;
use crate::screeninfo::ScreenInfo;
use crate::viewer::Viewer;


use bevy::{prelude::*, window::PresentMode, render::camera::CameraProjectionPlugin};

pub fn cycle_msaa(input: Res<Input<KeyCode>>, mut msaa: ResMut<Msaa>) {
    if input.just_pressed(KeyCode::M) {
        if msaa.samples == 4 {
            info!("Not using MSAA");
            msaa.samples = 1;
        } else {
            info!("Using 4x MSAA");
            msaa.samples = 4;
        }
    }
}

pub fn update_offaxis(mut query : Query<(
    &mut OffAxisProjection,
    &mut Transform,
    &ScreenInfo,
    &Viewer
)>
) {
    for (mut projection,mut transform,screen_info,viewer) in query.iter_mut() {

        // we fake access to far for updating the matrix
        (*projection).far *= 1.0;

        println!("Projection {:?}",*projection);
        
        println!("Screen Info {:?}",screen_info.name);

        println!("Viewer {:?}",viewer.position);

        *transform = Transform::from_translation(viewer.position).with_rotation(transform.rotation);



    }
}